#include "bioloid_dyn_slave.h"
#include "bioloid_time.h"
#include "usart3.h"

/* private variables */
TDynamixelSlave bioloid_dyn_slave;
TTime bioloid_dyn_slave_timer;
TComm bioloid_dyn_slave_comm;

// private functions
unsigned char bioloid_on_read(unsigned short int address,unsigned short int length,unsigned char *data)
{
  return 0x00;
}

unsigned char bioloid_on_write(unsigned short int address,unsigned short int length,unsigned char *data)
{
  return 0x00;
}

// public functions
void bioloid_dyn_slave_init(void)
{
  TUSART_IRQ_Priorities priorities;
  UART_InitTypeDef Init;

  // initialize timer structure
  time_init(&bioloid_dyn_slave_timer,bioloid_time_get_counts_per_us(),bioloid_time_get_counts);

  /* initialize the comm object */
  comm_init(&bioloid_dyn_slave_comm,0x01,&bioloid_dyn_slave_timer);
  Init.BaudRate     = 921600;
  Init.WordLength   = UART_WORDLENGTH_8B;
  Init.StopBits     = UART_STOPBITS_1;
  Init.Parity       = UART_PARITY_NONE;
  Init.Mode         = UART_MODE_TX_RX;
  Init.HwFlowCtl    = UART_HWCONTROL_NONE;
  Init.OverSampling = UART_OVERSAMPLING_16;

  priorities.irq_priority=0;
  priorities.irq_subpriority=0;
  priorities.dma_rx_priority=1;
  priorities.dma_rx_subpriority=1;
  priorities.dma_tx_priority=1;
  priorities.dma_tx_subpriority=0;

  usart3_init(&bioloid_dyn_slave_comm,&Init,&priorities);
  dyn_slave_init(&bioloid_dyn_slave,&bioloid_dyn_slave_comm,0x01);
  bioloid_dyn_slave.on_read=bioloid_on_read;
  bioloid_dyn_slave.on_write=bioloid_on_write;
  //dyn_slave_set_return_delay(&battery_dyn_slave,ram_data[BATTERY_RETURN_DELAY_TIME]);
  //dyn_slave_set_return_level(&battery_dyn_slave,ram_data[BATTERY_STATUS_RETURN_LEVEL]);
}

